import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Gubma here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Goomba extends Actor
{
    /**
     * Act - do whatever the Gubma wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private int yVelocity = 0;
    private boolean falling = true;
    protected boolean walkingRight = false;
    private static final int moveSpeed = 2;
    int relX = -1;
    int relY = -1;
    public int animationCounter = 0;
    public boolean alive = true;
    
    /*
     * All the Goomba animations
     */
    GreenfootImage GoombaStillRight = new GreenfootImage("Goomba_Still_Larger_Right.png");
    GreenfootImage GoombaRight1 = new GreenfootImage("Goomba_Walking_1_Larger_Right.png");
    GreenfootImage GoombaRight2 = new GreenfootImage("Goomba_Walking_2_Larger_Right.png");
    GreenfootImage GoombaRight3 = new GreenfootImage("Goomba_Walking_3_Larger_Right.png");
    GreenfootImage GoombaRight4 = new GreenfootImage("Goomba_Walking_4_Larger_Right.png");
    GreenfootImage GoombaStillLeft = new GreenfootImage("Goomba_Still_Larger.png");
    GreenfootImage GoombaLeft1 = new GreenfootImage("Goomba_Walking_1_Larger.png");
    GreenfootImage GoombaLeft2 = new GreenfootImage("Goomba_Walking_2_Larger.png");
    GreenfootImage GoombaLeft3 = new GreenfootImage("Goomba_Walking_3_Larger.png");
    GreenfootImage GoombaLeft4 = new GreenfootImage("Goomba_Walking_4_Larger.png");
    
    GreenfootSound GoombaDie = new GreenfootSound("SMB_GoombaKill.mp3");
    int RightImage = 0;
    int LeftImage = 0;
    
    public void killSelf()
    {
        /**
         * Kills the current Goomba by setting "alive".
         * to false
         */
        alive = false;
        if (walkingRight == true)
        {
            setImage(GoombaStillRight);
        }
        else
        {
            setImage(GoombaStillLeft);
        }  
    }
    public void act() 
    {
        //System.out.println(String.valueOf(this) + getX());
        //System.out.println(relX);
        //System.out.println(this + ", " + relX);
        //movement();
        //gravity();
        //setLocation(BlockParent.blockX+relX, BlockParent.blockY+relY);
    }
    private void setRelLocation(int X, int Y)
    {
        /**
         * Sets the location of the relative Goomba to X, Y.
         * 
         */
        relX = X;
        relY = Y;
        this.setLocation(BlockParent.blockX+getRelX(), BlockParent.blockY+getRelY());
    }
    private int getRelX()
    {
        /**
         * Returns the relative X position of the Goomba.
         */
        return relX;
    }
    private int getRelY()
    {
        /**
         * Returns the relative Y position of the Goomba.
         */
        return relY;
    }
    public void movement()
    {
        if (walkingRight == true && alive == true)
        {
            walkingRight = true;
            setRelLocation(getRelX()+moveSpeed, getRelY());
            if (getOneIntersectingObject(Block.class) != null ||
                    getOneIntersectingObject(GroundBlock.class) != null)
            {
                while (getOneIntersectingObject(Block.class) != null ||
                        getOneIntersectingObject(GroundBlock.class) != null)
                {
                    setRelLocation(getRelX()-2, getRelY());
                    walkingRight = false;
                    //System.out.println("moving left to avoid collision");
                }
            }
            if (animationCounter >= 3)
            {
                if (RightImage == 0)
                {
                    setImage(GoombaRight1);
                    RightImage = 1;
                    animationCounter = 0;
                }
                else if (RightImage == 1)
                {
                    setImage(GoombaRight2);
                    RightImage = 2;
                    animationCounter = 0;
                }
                else if (RightImage == 2)
                {
                    setImage(GoombaRight3);
                    RightImage = 3;
                    animationCounter = 0;
                }
                else if (RightImage == 3)
                {
                    setImage(GoombaRight4);
                    RightImage = 4;
                    animationCounter = 0;
                }
                else if (RightImage == 4)
                {
                    setImage(GoombaRight1);
                    RightImage = 1;
                    animationCounter = 0;
                }
            }
            
        }
        else if (walkingRight == false && alive == true)
        {
            walkingRight = false;
            setRelLocation(getRelX()-moveSpeed, getRelY());
            if (getOneIntersectingObject(Block.class) != null ||
                    getOneIntersectingObject(GroundBlock.class) != null)
            {
                while (getOneIntersectingObject(Block.class) != null ||
                        getOneIntersectingObject(GroundBlock.class) != null)
                {
                    setRelLocation(getRelX()+2, getRelY());
                    walkingRight = true;
                    //System.out.println("moving right to avoid collision");
                }
            }
            if (animationCounter >= 3)
            {
                if (LeftImage == 0)
                {
                    setImage(GoombaLeft1);
                    LeftImage = 1;
                    animationCounter = 0;
                }
                else if (LeftImage == 1)
                {
                    setImage(GoombaLeft2);
                    LeftImage = 2;
                    animationCounter = 0;
                }
                else if (LeftImage == 2)
                {
                    setImage(GoombaLeft3);
                    LeftImage = 3;
                    animationCounter = 0;
                }
                else if (LeftImage == 3)
                {
                    setImage(GoombaLeft4);
                    LeftImage = 4;
                    animationCounter = 0;
                }
                else if (LeftImage == 4)
                {
                    setImage(GoombaLeft1);
                    LeftImage = 1;
                    animationCounter = 0;
                }
            }
        }
        if (alive == false)
        {
            if (getImage().getHeight() > 2)
            {
                getImage().scale(getImage().getWidth(), getImage().getHeight() - 24);
                setRelLocation(getRelX(), getRelY() + 12);
                GoombaDie.play();
                return;
            }
            else
            {
                getWorld().removeObject(this);
                return;
            }
        }
        animationCounter++;
    }
    public void gravity()
    {
        if (alive == false)
        {
            return;
        }
        yVelocity += Mario.gravity;
        setRelLocation(getRelX(), getRelY() + yVelocity);
        falling = true;
        if ((getOneIntersectingObject(Block.class) != null ||
                getOneIntersectingObject(GroundBlock.class) != null) && yVelocity <0)
        {
            while (getOneIntersectingObject(Block.class) != null ||
                    getOneIntersectingObject(GroundBlock.class) != null)
            {
                setRelLocation(getRelX(), getRelY()+1);
                yVelocity = 0;
            }
            setRelLocation(getRelX(), getRelY()+1);
        }
        if (getOneIntersectingObject(Block.class) != null ||
                getOneIntersectingObject(GroundBlock.class) != null)
        {
            while (getOneIntersectingObject(Block.class) != null ||
                    getOneIntersectingObject(GroundBlock.class) != null)
            {
                setRelLocation(getRelX(), getRelY()-1);
                falling = false;
                yVelocity = 0;
            }
        }

    }
}
