import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class Level here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Level extends World
{

    /**
     * Constructor for objects of class Level.
     * 
     */
    GreenfootSound theme = new GreenfootSound("SMB_Theme.mp3");
    GreenfootImage backGround = new GreenfootImage("BackGround.png");
    
    public Level(GreenfootImage level, int livesToBe)
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(800, 600, 1, false);
        setBackground(new GreenfootImage("Loading...", 100, Color.BLACK, new Color(0, 0, 0, 0)));
        generateBlocks(level, livesToBe);
        setBackground(backGround);
        //reset objects in the world
        BlockParent.blockX = 0;
        BlockParent.blockY = 0;
        Gui.scoreLong = 0;
        Player.isAlive = true;
    }
    public void act()
    {
        //System.out.println("hi");
        if (Player.isAlive == false)
        {
            theme.stop();
        }
        else 
        {
            theme.playLoop();
        }
        if (Greenfoot.isKeyDown("escape"))
        {
            theme.stop();
            removeObjects(getObjects(null));
            Greenfoot.setWorld(new MainMenu());
        }
    }
    public void generateBlocks(GreenfootImage blocks, int futureLives)
    {
        //populate the world based on Level (.png) variable
        addObject(new BackDrop(4700, getHeight()/2), 4700, getHeight()/2);
        for (int j = 0; j < blocks.getHeight(); j++)
        {
            //sudo J, I
            for (int i = 0; i < blocks.getWidth(); i++)
            {
                //System.out.println(blocks.getHeight()-1);
                if (blocks.getColorAt(i, j).equals(Color.RED))
                {
                    //System.out.println("block at " + i + "," + j);
                    addObject(new Block(i*50+25, j*50+25), i*50+25, j*50+25);
                }
                else if (blocks.getColorAt(i, j).equals(Color.GREEN))
                {
                    addObject(new Coin(i*50+25, j*50+25), i*50+25, j*50+25);
                }
                else if (blocks.getColorAt(i, j).equals(Color.BLUE))
                {
                    addObject(new GroundBlock(i*50+25, j*50+25), i*50+25, j*50+25);
                }
                else if (blocks.getColorAt(i, j).equals(Color.YELLOW))
                {
                    addObject(new Player(), i*50+25, j*50+25);
                }
                else if (blocks.getColorAt(i, j).equals(Color.MAGENTA))
                {
                    addObject(new SubGoomba(i*50+25, j*50+25), i*50+25, j*50+25);
                }
            }
        }
        addObject(new Gui(), 82, 20); //adds gui object to keep score
        addObject(new LivesGui(futureLives), 800-82, 20);
    }
    
    public void started()
    {
        theme.setVolume(75);
        theme.playLoop();
    }
    public void stopped()
    {
        theme.stop();
    }
}
