import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Mario here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Mario extends Actor
{
    /**
     * Act - do whatever the Mario wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */

    //Images===========================================================================//
    GreenfootImage walk_1_right = new GreenfootImage("Mario_Walk_1_smaller.png");      //
    GreenfootImage walk_2_right = new GreenfootImage("Mario_Walk_2_smaller.png");      //
    GreenfootImage Jumping_right = new GreenfootImage("Mario_Jump_smaller.png");       //
    GreenfootImage Still_right = new GreenfootImage("Mario_Still_smaller.png");        //
    GreenfootImage walk_1_left = new GreenfootImage("Mario_Walk_1_Left_smaller.png");  //
    GreenfootImage walk_2_left = new GreenfootImage("Mario_Walk_2_Left_smaller.png");  //
    GreenfootImage Jumping_left = new GreenfootImage("Mario_Jump_Left_smaller.png");   //
    GreenfootImage Still_left = new GreenfootImage("Mario_Still_Left_smaller.png");    //
    //End Images=======================================================================//
    
    GreenfootSound jumpSound = new GreenfootSound("SMB_Jump.mp3");
    GreenfootSound deathSound = new GreenfootSound("SMB_MarioDie.mp3");
    
    public static int moveSpeed = 7;        //keeps track player movement
    boolean walking = false;                //if the player is walking or not
    int image = 0;                          //var that keeps tracks of animation
    int walkingCounter = 0;
    boolean walkingRight = true;
    public static boolean isAlive = true;   //if the player is alive
        
    public void debug()
    {
        //Simple debug method
        //System.out.println(yVelocity);
    }
    
    public void act() 
    {
        //does nothing
    }
    
    
    //==================================================//
    //============START OF WALKING CODE=================//
    //==================================================//
    public void movement()
    {
        if (Greenfoot.isKeyDown("shift"))
        {
            moveSpeed = 10;
        }
        else
        {
            moveSpeed = 7;
        }
        
        if (Greenfoot.isKeyDown("right"))
        {
            walking = true;
            walkingRight = true;
            walkImage();
            setLocation(getX()+moveSpeed, getY());
            if (getOneIntersectingObject(Block.class) != null || getOneIntersectingObject(GroundBlock.class) != null)
            {
                while (getOneIntersectingObject(Block.class) != null || getOneIntersectingObject(GroundBlock.class) != null)
                {
                    setLocation(getX()-2, getY());
                    //System.out.println("moving left to avoid collision");
                }
            }
        }
        else if (Greenfoot.isKeyDown("left"))
        {
            walking = true;
            walkingRight = false;
            walkImage();
            setLocation(getX()-moveSpeed, getY());
            if (getOneIntersectingObject(Block.class) != null || getOneIntersectingObject(GroundBlock.class) != null)
            {
                while (getOneIntersectingObject(Block.class) != null || getOneIntersectingObject(GroundBlock.class) != null)
                {
                    setLocation(getX()+2, getY());
                    //System.out.println("moving right to avoid collision");
                }
            }
        }
        else
        {
            walking = false;
            walkImage();
            walkingCounter = 0;
        }
        if (Greenfoot.isKeyDown("up"))
        {
            if (falling == false || canJump() == true)
            {
             jump();   
            }
        }
        else
        {
            jumpPower = 6;
            ableToJump = false;
        }
    }
    public void walkImage()
    {
        if (falling == false)
        {
            if (walking && walkingRight && walkingCounter == 0)
            {
                setImage(walk_1_right);
                image = 1;
            }
            else if (walking && walkingCounter == 0)
            {
                setImage(walk_1_left);
                image = 1;
            }
            if (walking && walkingCounter >= 5)
            {
                walkingCounter = 0;
                if (walkingRight)
                {
                    if (image == 1)
                    {
                        setImage(walk_2_right);
                        image = 2;
                    }
                    else
                    {
                        setImage(walk_1_right);
                        image = 1;
                    }
                }
                else
                {
                    if (image == 1)
                    {
                        setImage(walk_2_left);
                        image = 2;
                    }
                    else
                    {
                        setImage(walk_1_left);
                        image = 1;
                    }
                }
            }
            if (walking == false && walkingRight == true)
            {
                setImage(Still_right);
            }else if (walking == false && walkingRight == false)
            {
                setImage(Still_left);
            }
            
            walkingCounter += 1;
        }
        else
        {
            if (walkingRight == true)
            {
                setImage(Jumping_right);
            }
            else if (walkingRight == false)
            {
                setImage(Jumping_left);
            }
        }
    }
    //===================================================//
    //=============END OF WALKING CODE===================//
    //===================================================//
    
    
    //===================================================//
    //==============START OF JUMP CODE===================//
    //===================================================//
    public static final int maxJumpPower = 20;
    int jumpPower = 6;
    boolean ableToJump = true;
    public void jump()
    {
        //setLocation(getX(), getY()-1);
        if (canJump() == true && ableToJump == true)
        {
            yVelocity = - jumpPower;
            falling = true;
            jumpSound.play();
            while(getOneIntersectingObject(Block.class) != null)
            {
                getWorld().removeObject(getOneIntersectingObject(Block.class));
                ableToJump = false;
            }
        }
    }
    
    private boolean canJump()
    {
        if (jumpPower < maxJumpPower)
        {
            jumpPower += 2;
            return true;
        }
        if (jumpPower == maxJumpPower)
        {
            ableToJump = false;
            return false;
        }
        return false;
    }
    //===================================================//
    //===============END OF JUMP CODE====================//
    //===================================================//
    
    
    //===================================================//
    //=============START OF GRAVITY CODE=================//
    //===================================================//
    public static final int gravity = 1;
    public static int yVelocity = 0;
    public static boolean falling = true;
    GreenfootSound coinGet = new GreenfootSound("SMB_Coin.mp3");
    
    public void gravity()
    {
        yVelocity += gravity;
        setLocation(getX(), getY() + yVelocity);
        falling = true;
        if ((getOneIntersectingObject(Block.class) != null || getOneIntersectingObject(GroundBlock.class) != null) && yVelocity <0)
        {
            while(getOneIntersectingObject(Block.class) != null)
            {
                getWorld().removeObject(getOneIntersectingObject(Block.class));
                yVelocity = 0;
                coinGet.stop();
                coinGet.play();
                Gui.scoreLong += 10;
            }
            while (getOneIntersectingObject(Block.class) != null || getOneIntersectingObject(GroundBlock.class) != null)
            {
                setLocation(getX(), getY()+1);
                yVelocity = 0;
            }
            setLocation(getX(), getY()+1);
        }
        if (getOneIntersectingObject(Block.class) != null || getOneIntersectingObject(GroundBlock.class) != null)
        {
            while (getOneIntersectingObject(Block.class) != null || getOneIntersectingObject(GroundBlock.class) != null)
            {
                setLocation(getX(), getY()-1);
                falling = false;
                ableToJump = true;
                yVelocity = 0;
            }
        }
        //if (getY() >= getWorld().getHeight()-51)
        //{
        //    setLocation(getX(), getWorld().getHeight()-51);
        //    falling = false;
        //    yVelocity = 0;
        //}
    }
    //===================================================//
    //===============END OF GRAVITY CODE=================//
    //===================================================//
    
    
    /*
     * kills the player and add a death object which plays an animation
     */
    public void die()
    {
        isAlive = false;
        deathSound.play();
        LivesGui.lives--;
        getWorld().addObject(new Death(), getX(), getY());
        getWorld().removeObject(this);
        //System.out.println("I'm Dead");
        return; 
    }
    
    
    
    
    //===================================================//
    //=============START OF GOOMBA CODE==================//
    //===================================================//
    public boolean goombaDie()
    {
        if (getOneIntersectingObject(SubGoomba.class) != null && falling == false)
        {
            die();
            return true;
        }
        else
        {
            return false;
        }
    }
       
    //===================================================//
    //==============END OF GOOMBA CODE===================//
    //===================================================//
}
